package cz.muni.fi.pa165.controller;

import cz.muni.fi.pa165.model.TeamMemberDTO;
import cz.muni.fi.pa165.service.TeamMemberService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class TeamMemberControllerImpl implements TeamMemberController {
    private final TeamMemberService teamMemberService;

    @Autowired
    public TeamMemberControllerImpl(TeamMemberService teamMemberService) {
        this.teamMemberService = teamMemberService;
    }

    @Override
    public ResponseEntity<TeamMemberDTO> createTeamMember(TeamMemberDTO teamMemberDTO) {
        return ResponseEntity.status(HttpStatus.CREATED).body(teamMemberService.createTeamMember(teamMemberDTO));
    }

    @Override
    public ResponseEntity<TeamMemberDTO> getTeamMemberById(long id) {
        return ResponseEntity.ok(teamMemberService.getTeamMemberByID(id));
    }

    @Override
    public ResponseEntity<TeamMemberDTO> updateTeamMemberById(long id, TeamMemberDTO teamMemberDTO) {
        return ResponseEntity.ok(teamMemberService.updateTeamMemberByID(teamMemberDTO));
    }

    @Override
    public ResponseEntity<Void> removeTeamMemberById(long id) {
        teamMemberService.removeTeamMemberByID(id);
        return ResponseEntity.noContent().build();
    }

}
